# Memento — Nextcloud web archive server

If you host snapshots of web pages on your Nextcloud, this app enables any client that speaks the
Memento protocol to access these snapshots.

The Memento protocol ([RFC7089][]) is widely used to ask archives (such as the Internet Archive's
[Wayback Machine][]) for their copies of web pages. For example, a client (e.g. a browser extension)
may ask an archive whether it has a copy of `https://nextcloud.com` from around July last year, and
—if successful— will be redirected to the closest match.

Currently this app only supports snapshots that are stored as plain html files. It recognises a file
as being a snapshot if the file contains a &lt;link&gt; to the location of the original page; such
snapshots can be created using [Freeze-dry][].

This app requires the app [Raw][] to also be installed, in order to host the snapshots.

## Usage

The app presents a Memento TimeGate at the `/timegate/{url}` route.

For example, assume you have an html file `example.html` in the folder `Documents/snapshots`. If
this file contains a `<link rel="origin" href="https://example.org">` in its `<head>`, it will be
recognised as a snapshot of `https://example.org`. Visiting
`/apps/memento/timegate/https://example.org` would then redirect you to
`/apps/raw/files/Documents/snapshots/example.html` (hence you need the [Raw] app as well).

In a typical Memento client (e.g. the [Memento Time Travel][] browser extension), you would add your
personal archive as `https://my-nextcloud/apps/memento/timegate/` (of course first replace
`my-nextcloud` appropriately).

A TimeMap is also exposed, at the `/timemap/{url}` route, to list all available snapshots of a URL.
For details, look at the documentation of the Memento protocol ([RFC7089][]).

[Memento Time Travel]: https://addons.mozilla.org/en-US/firefox/addon/memento-timetravel/
[RFC7089]: https://tools.ietf.org/html/rfc7089
[Wayback Machine]: https://web.archive.org/
[Freeze-dry]: https://github.com/WebMemex/freeze-dry
[Raw]: https://code.treora.com/gerben/nextcloud-raw
